#!/usr/bin/python
#  -*- coding: utf-8 -*-

import sys, os
from optparse import OptionParser

def change_charset(source, options):
	try:
		old_name = source + '.' + options.save_extension
		os.rename(source, old_name) 

		command = 'iconv -f ' + options.old_charset + ' -t ' + options.new_charset + ' ' + old_name + ' > ' + source
		ret = os.system(command)

		# for copy permission... nakada
		st = os.stat(old_name)
		perm = oct(st.st_mode)[-4:]
		os.system("chmod %(mode)s %(file)s" % {'mode':perm, 'file':source})
		# end permission

		if ret <> 0:
			print source + '   ---Fail'
		else:
			if options.nobackup is True:
				os.remove(old_name)
			print source + '   ...Success'

	except:
		print source + '    ---Fail'

usage = "%prog -f [options] file1, file2, file3... (or *.txt, *) \n\tor %prog -d<directory> [options]"
parser = OptionParser(usage=usage)

parser.add_option("-r", '--recursive', dest='recursive', action='store_true', default=False, help='change subdirectory files')
parser.add_option("-f", '--files', dest='files', action='store_true', default=False, help='change user input files')
parser.add_option("-x", '--nobackup', dest='nobackup', action='store_true', default=False, 	help='remove old files')
parser.add_option("-d", '--directory', dest='directory', default='', help='set working directory')
parser.add_option("-s", '--sav', dest='save_extension', default='chg', help='set bakcup file extension(default:chg)')
parser.add_option("-e", '--ext', dest='extension', default='txt', help='set working file extension')
parser.add_option("-o", '--old', dest='old_charset', default='euc-kr', help='current character set(default:euc-kr)')
parser.add_option("-n", '--new', dest='new_charset', default='utf-8', help='new character set(default:utf-8)')

(options, args) = parser.parse_args()

err_message = '';
if options.files is True:
	if options.directory <> '':
		err_message = '\'-f\' and \'-d\' can\'t be used together'
	if options.recursive is True:
		err_message = '\'-r\' and \'-r\' cna\'t be used together'
else:
	if options.directory == '':
		err_message = 'No working directory'
	else:
		if os.path.isdir(options.directory) is False:
			err_message = options.directory + 'is invalid directory'

if err_message <> '':
	print 'Error: "' + err_message + '"'
	parser.print_help()
	sys.exit(0)

if options.files is True:
	argCount = len(sys.argv)
	if argCount is 1:
		print 'No input files. Try \'chgchar -h\' for help.'
		sys.exit(0)

	for arg in sys.argv[1:]:
		if os.path.isfile(arg):
			change_charset(arg, options)
else:
	for root, dirs, files in os.walk(options.directory):
		for name in files:
			target_file = os.path.join(root, name)
			target_ext = os.path.splitext(target_file)[1][1:]

			is_change = True

			if options.extension <> '*' and options.extension <> target_ext:
				is_change = False

			if options.recursive is False and os.path.dirname(target_file) <> os.path.dirname(options.directory):
				is_change = False

			if is_change is True:
				change_charset(target_file, options)

